package dk.apaq.crud;

/**
 *  Event used when Crud's notifies of its actions.
 */
public class CrudEvent<IDT, BT extends HasId<IDT>> {

    private final Crud<IDT, BT> crud;
    
    public CrudEvent(Crud<IDT, BT> crud) {
        this.crud = crud;
    }

    public Crud<IDT, BT> getCrud() {
        return crud;
    }

    

    public static class WithId<IDT, BT extends HasId<IDT>> extends CrudEvent<IDT, BT> {

        private final IDT id;

        public WithId(Crud<IDT,BT> crud, IDT id) {
            super(crud);
            this.id = id;
        }

        public IDT getEntityId() {
            return id;
        }
    }

    public static class WithEntity<IDT, BT extends HasId<IDT>> extends CrudEvent<IDT, BT> {

        private final BT bean;

        public WithEntity(Crud<IDT, BT> crud, BT bean) {
            super(crud);
            this.bean = bean;
        }

        public BT getEntity() {
            return bean;
        }
    }
}
