package dk.apaq.crud.core;

import dk.apaq.crud.CrudEvent;
import dk.apaq.crud.CrudListener;
import dk.apaq.crud.HasId;

/**
 * An abstract implementation of a <code>CrudListener</code> that has empty implementations
 * of all methods in  the interface. A class can extend this class and only implement the methods it need.
 */
public abstract class BaseCrudListener<IDT, BT extends HasId<IDT>> implements CrudListener<IDT, BT> {

    @Override
    public void onBeforeEntityCreate(CrudEvent<IDT, BT> event) { /* EMPTY */ }

    @Override
    public void onBeforeEntityDelete(CrudEvent.WithId<IDT, BT> event) { /* EMPTY */ }

    @Override
    public void onBeforeEntityRead(CrudEvent.WithId<IDT, BT> event) { /* EMPTY */ }

    @Override
    public void onBeforeEntityUpdate(CrudEvent.WithEntity<IDT, BT> event) { /* EMPTY */ }

    @Override
    public void onEntityCreate(CrudEvent.WithEntity<IDT, BT> event) { /* EMPTY */ }

    @Override
    public void onEntityDelete(CrudEvent.WithId<IDT, BT> event) { /* EMPTY */ }

    @Override
    public void onEntityRead(CrudEvent.WithEntity<IDT, BT> event) { /* EMPTY */ }

    @Override
    public void onEntityUpdate(CrudEvent.WithEntity<IDT, BT> event) { /* EMPTY */ }


}
